﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;
using Infragistics.Win;
using System.Diagnostics;
using System.Reflection;

namespace MemDataTable_CS
{
    public partial class Form1 : Form
    {
        private DataTable dt1;

        public Form1()
        {
            InitializeComponent();

            this.ultraGrid1.CreationFilter = new GroupByRowMultilineCreationFilter();
            this.ultraGrid1.InitializeGroupByRow += UltraGrid1_InitializeGroupByRow;
        }       

        private void Form1_Load(object sender, EventArgs e)
        {
            // Set grid's DataSource
            dt1 = DummyDataCreator.GetData(20);
            dt1.Columns.Remove("Key");
            dt1.TableName = "Band 0";

            dt1.Columns["String 1"].ColumnName = "Country";
            foreach (DataRow row in this.dt1.Rows)
            {
                switch (DummyDataCreator.RandomInt(1, 3))
                {
                    case 1:
                        row["Country"] = "USA:" + Environment.NewLine + "area, population, language";
                        break;
                    case 2:
                        row["Country"] = "Canada:" + Environment.NewLine + "area, population, language";
                        break;
                    case 3:
                        row["Country"] = "Mexico:" + Environment.NewLine + "area, population, language";
                        break;
                }                
            }

            dt1.AcceptChanges();
            this.ultraGrid1.DataSource = dt1;
        }
        
        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            var layout = e.Layout;
            var band = layout.Bands[0];
            var ov = layout.Override;

            layout.ViewStyleBand = ViewStyleBand.OutlookGroupBy;
            band.SortedColumns.Add("Country", false, true);            
        }

        private void ultraGrid1_InitializeRow(object sender, InitializeRowEventArgs e)
        {
            
        }

        private void UltraGrid1_InitializeGroupByRow(object sender, InitializeGroupByRowEventArgs e)
        {
            e.Row.Height = 80;
            e.Row.Description = e.Row.Value.ToString() + Environment.NewLine + "Line 2";
        }      
    }
}
